/* Some macros to make FreeBSD code compile elsewhere. */

#if defined(__FreeBSD__)
# define OS_FreeBSD
#elif defined(__OpenBSD__)
# define OS_OpenBSD
#elif defined(__NetBSD__)
# define OS_NetBSD
#elif defined(linux)
# define OS_Linux
#elif defined(sun)
# define OS_Solaris
#elif defined(__osf__)
# define OS_DigitalUnix
#elif defined(__svr4__)
# define OS_SysV
#else
# define OS_UNKNOWN
#endif

#ifndef OS_FreeBSD
#define _GNU_SOURCE
#define __USE_XOPEN
#define NO_HISTORY
#define __FBSDID(id)
#define __dead2 __attribute__((noreturn))
#define __printflike(farg,varg) __attribute__((format(printf,farg,varg)))
#define __printf0like(farg,varg) __attribute__((format(printf,farg,varg)))
#define inline
#define __DECONST(type, var) ((type)(uintptr_t)(const void *)(var))
#define _ALIGNBYTES (sizeof(register_t) - 1)
#define _ALIGN(p) (((uintptr_t)(p) + _ALIGNBYTES) & ~_ALIGNBYTES)
#define ALIGNBYTES _ALIGNBYTES
#define ALIGN(p) _ALIGN(p)
#define eaccess(path,mode) access(path,mode)
#endif

#ifdef OS_Linux
#define S_ISTXT S_ISVTX
static const char *sys_signame[64] = {
    "SIGNAL 0", "HUP", "INT", "QUIT", "ILL", "TRAP", "ABRT", "BUS", "FPE",
    "KILL", "USR1", "SEGV", "USR2", "PIPE", "ALRM", "TERM", "STKFLT", "CHLD",
    "CONT", "STOP", "TSTP", "TTIN", "TTOU", "URG", "XCPU", "XFSZ", "VTALRM",
    "PROF", "WINCH", "POLL", "PWR", "SYS",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "",
    "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", ""
    };
#endif
